#pragma once
#include "entity.h"

enum { MAX_ENTITIES = 128 };

typedef struct Game {
	unsigned int uuid;
	bool queue_next_scene;
	int queue_restart_scene;
	Entity entities[MAX_ENTITIES];
} Game;

void game_init(Game *this);
void game_deinit(Game *this);
void game_update(Game *this);
void game_draw(Game *this);
void game_restart_scene(Game *this);
Entity *game_create_entity(Game *this);
int game_entity_count(Game *this, unsigned int type);
